<!---
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 
Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.
 
The Original Code is comprised of the PT Calendar directory
 
The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2013.
All Rights Reserved.
 
By downloading, modifying, distributing, using and/or accessing any files
in this directory, you agree to the terms and conditions of the applicable
end user license agreement.
--->
<!---
/* *************************************************************** */
Author: 	
	PaperThin, Inc.
	G. Cronkright 
Custom Field Type:
	Calendar Organization Radio Buttons Field
Name:
	calendar_org_radio_buttons_props.cfm
Summary:
	Custom Field to select Organizations from Radio Button list
	with a select all option. Also can be bound to the event category 
	checkbox field to display category checkbox options based on the selected
	organization
History:
	2011-08-18 - GAC - Created
	2013-09-19 - GAC - Added a renderField option to allow the field to be hidden
--->
<cfscript>
	// initialize some of the attributes variables
	typeid = attributes.typeid;
	prefix = attributes.prefix;
	formname = attributes.formname;
	currentValues = attributes.currentValues;

	// Setup the default values
	defaultValues = StructNew();
	defaultValues.orgFieldID = "";
	defaultValues.catFieldID = "";
	defaultValues.forceScripts = "0";
	defaultValues.useOnlyAciveOrgs = "1";
	defaultValues.useALLoption = "1";
	defaultValues.allOptionLabel = ""; // Default is blank since the App with use a value from the Config: All Organizations
	defaultValues.allOptionValueType = "useconfig"; // 'none', 'all', 'custom' or 'useconfig'
	defaultValues.allOptionValue = "";	
	defaultValues.defaultOptionType = "useconfig"; // 'none', 'all', 'record' or 'useconfig'
	defaultValues.defaultOptionValue = "";
	defaultValues.optionSortField = "useconfig";
	//defaultValues.optionSortField = "name"; // name or ordinal
	defaultValues.renderField = "yes";
	
	// This will override the current values with the default values.
	// In normal use this should not need to be modified.
	defaultValueArray = StructKeyArray(defaultValues);
	for(i=1;i<=ArrayLen(defaultValueArray);i++){
		// If there is a default value to exists in the current values
		//	AND the current value is an empty string
		//	OR the default value does not exist in the current values
		if( ( StructKeyExists(currentValues, defaultValueArray[i]) 
				AND (NOT LEN(currentValues[defaultValueArray[i]])) )
				OR (NOT StructKeyExists(currentValues, defaultValueArray[i])) ){
			currentValues[defaultValueArray[i]] = defaultValues[defaultValueArray[i]];
		}
	}
</cfscript>

<cfoutput>
	<style>
		##allOptionCustomValueLayer, ##defaultOptionRecordValueLayer {
			display:none;
		}
	</style>
	
	<cfscript>
		application.ADF.scripts.loadJQuery(noConflict=true);
	</cfscript>
	
	<script language="JavaScript" type="text/javascript">
		// register the fields with global props object
		fieldProperties['#typeid#'].paramFields = '#prefix#orgFieldID,#prefix#catFieldID,#prefix#forceScripts,#prefix#useOnlyAciveOrgs,#prefix#useALLoption,#prefix#allOptionLabel,#prefix#allOptionValue,#prefix#allOptionValueType,#prefix#defaultOptionType,#prefix#defaultOptionValue,#prefix#optionSortField,#prefix#renderField';
		// allows this field to support the orange icon (copy down to label from field name)
		fieldProperties['#typeid#'].jsLabelUpdater = '#prefix#doLabel';
		// allows this field to have a common onSubmit Validator
		//fieldProperties['#typeid#'].jsValidator = '#prefix#doValidate';
		// handling the copy label function
		function #prefix#doLabel(str) {
			document.#formname#.#prefix#label.value = str;
		}
		
		/*	function #prefix#doValidate()
			{
				//set the default msgvalue
				document.#formname#.#prefix#msg.value = 'Please enter some text to be converted';
				if( document.#formname#.#prefix#foo.value.length == 0 )
				{
					alert('please Enter some data for foo');
					return false;
				}
				return true;
			}
		*/
		
		jQuery(document).ready(function(){
			
			jQuery("##allOptionCustomValueLayer").hide();
			jQuery("##defaultOptionRecordValueLayer").hide();
			jQuery("##defaultOptionCustomValueLayer").hide();
			
			// All Option
			if ( jQuery("input[name='#prefix#allOptionValueType']:checked").val() == 'custom' ){
				jQuery("##allOptionCustomValueLayer").show("slow");
			}
			// Default Options
			if ( jQuery("input[name='#prefix#defaultOptionType']:checked").val() == 'custom' ){
				jQuery("##defaultOptionCustomValueLayer").show("slow");
			} 
			if ( jQuery("input[name='#prefix#defaultOptionType']:checked").val() == 'record' ){
				jQuery("##defaultOptionRecordValueLayer").show("slow");
			} 
			
			// All Option - click event
			jQuery("input[name='#prefix#allOptionValueType']").change(function(){
				if ( jQuery("input[name='#prefix#allOptionValueType']:checked").val() == 'custom' ){	
					jQuery("##allOptionCustomValueLayer").show("slow");
				}
				else {
					jQuery("##allOptionCustomValueLayer").hide("slow");
					jQuery("###prefix#allOptionValueInput").val("");	
				}
			});
			
			// Default Options - click event
			jQuery("input[name='#prefix#defaultOptionType']").change(function(){
				if ( jQuery("input[name='#prefix#defaultOptionType']:checked").val() == 'custom' ){
					jQuery("##defaultOptionRecordValueLayer").hide("slow");	
					jQuery("##defaultOptionCustomValueLayer").show("slow");
					jQuery("###prefix#defaultOptionValueSelect").val("");
				}
				else if ( jQuery("input[name='#prefix#defaultOptionType']:checked").val() == 'record' ){
					jQuery("##defaultOptionCustomValueLayer").hide("slow");
					jQuery("##defaultOptionRecordValueLayer").show("slow");
					jQuery("###prefix#defaultOptionValueInput").val("");
				}
				else {
					jQuery("##defaultOptionCustomValueLayer").hide("slow");			
					jQuery("##defaultOptionRecordValueLayer").hide("slow");	
					jQuery("###prefix#defaultOptionValueSelect").val("");
					jQuery("###prefix#defaultOptionValueInput").val("");
				}
			});	
		});
	</script>
	<table>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall">Organization and Category Field Bindings:</td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Organization Field ID:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap">
				<input type="text" name="#prefix#orgFieldID" id="#prefix#orgFieldID" value="#currentValues.orgFieldID#"size="40" />
			</td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Category Field ID:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap">
				<input type="text" name="#prefix#catFieldID" id="#prefix#catFieldID" value="#currentValues.catFieldID#" size="40" />
			</td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<!--- <tr>
			<td colspan="2" class="cs_dlgLabelSmall"></td>
		</tr> --->
		<tr>
			<td class="cs_dlgLabelSmall">Display Only Active Organizations:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap">
				Yes&nbsp;<input type="radio" id="#prefix#useOnlyAciveOrgsYes" name="#prefix#useOnlyAciveOrgs" value="1"<cfif currentValues.useOnlyAciveOrgs EQ "1"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				No&nbsp;<input type="radio" id="#prefix#useOnlyAciveOrgsNo" name="#prefix#useOnlyAciveOrgs" value="0"<cfif currentValues.useOnlyAciveOrgs EQ "0"> checked="checked"</cfif>><br />
			</td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Add an 'All' Option Radio Button:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap">
				Yes&nbsp;<input type="radio" id="#prefix#useALLoptionYes" name="#prefix#useALLoption" value="1"<cfif currentValues.useALLoption EQ "1"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				No&nbsp;<input type="radio" id="#prefix#useALLoptionNo" name="#prefix#useALLoption" value="0"<cfif currentValues.useALLoption EQ "0"> checked="checked"</cfif>><br />
			</td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">'All' Option Label:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap">
				<input type="text" name="#prefix#allOptionLabel" id="#prefix#allOptionLabel" value="#currentValues.allOptionLabel#" size="40" />
				<br/><span>Leave blank to use label from App config value</span>
			</td>
		</tr>
		<!--- // TODO: DO NOT USE - for reference only --->
		<!--- <tr>
			<td class="cs_dlgLabelSmall">'All' Option Value:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap">
				<input type="text" name="#prefix#allOptionValue" id="#prefix#allOptionValue" value="#currentValues.allOptionValue#" size="40" />
				<br/><span>Leave blank to use the App config value</span>
			</td>
		</tr> --->
		<!--- <input type="hidden" name="#prefix#allOptionValue" id="#prefix#allOptionValue" value="#currentValues.allOptionValue#" size="40" /> --->
		
		
		<input type="hidden" id="#prefix#allOptionValueTypeUseConfig" name="#prefix#allOptionValueType" value="#currentValues.allOptionValueType#" />
		<input type="hidden" id="#prefix#allOptionValue" name="#prefix#allOptionValue" value="#currentValues.allOptionValue#" />
		<!--- // TODO: GET THESE OPTIONS WORKING --->
		<!--- <tr>
			<td class="cs_dlgLabelSmall" valign="top">'All' Option Value:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap"> --->
				
				<!--- // TODO: USE THESE --->
				<!--- <input type="radio" id="#prefix#allOptionValueTypeNone" name="#prefix#allOptionValueType" value="none"<cfif currentValues.allOptionValueType EQ "none"> checked="checked"</cfif>>&nbsp;No Value [""]<br/>
				<input type="radio" id="#prefix#allOptionValueTypeAll" name="#prefix#allOptionValueType" value="all"<cfif currentValues.allOptionValueType EQ "all"> checked="checked"</cfif>>&nbsp;A List of All Available Options (comma-delimited)<br/>
				<input type="radio" id="#prefix#allOptionValueTypeCustom" name="#prefix#allOptionValueType" value="custom"<cfif currentValues.allOptionValueType EQ "custom"> checked="checked"</cfif>>&nbsp;Custom<br/>
				<div id="allOptionCustomValueLayer">
					<input type="text" name="#prefix#allOptionValue" id="#prefix#allOptionValueInput" value="#currentValues.allOptionValue#" size="40" />
				</div>
				<input type="radio" id="#prefix#allOptionValueTypeUseConfig" name="#prefix#allOptionValueType" value="useconfig"<cfif currentValues.allOptionValueType EQ "useconfig"> checked="checked"</cfif>>&nbsp;Use value from App Config<br/>

			</td>
		</tr> --->
		
<!--- // TODO: DO NOT USE - for reference only --->
<!--- <input type="radio" id="#prefix#allOptionValueTypeRecord" name="#prefix#allOptionValueType" value="record"<cfif currentValues.allOptionValueType EQ "record"> checked="checked"</cfif>>&nbsp;Select an Organization<br/>
<div id="allOptionRecordValueLayer">
	<select name="#prefix#allOptionValue" id="#prefix#allOptionValueSelect">
			<option value=""<cfif currentValues.allOptionValue EQ ""> selected="selected"</cfif>> - SELECT - </option>
		<cfif ArrayLen(orgData)>
			<cfloop from="1" to="#ArrayLen(orgData)#" index="itm">
				<option value="#orgData[itm].uniqueID#"<cfif currentValues.allOptionValue EQ orgData[itm].uniqueID> selected="selected"</cfif>>#orgData[itm].name#</option>
			</cfloop>
		</cfif> 
	</select>
</div> --->	
		
		<!--- <tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>  --->
		
		<input type="hidden" id="#prefix#defaultOptionTypeUseConfig" name="#prefix#defaultOptionType" value="#currentValues.defaultOptionType#" />
		<input type="hidden" id="#prefix#defaultOptionValue" name="#prefix#defaultOptionValue" value="#currentValues.defaultOptionValue#" />
		<!--- // TODO: GET THESE OPTIONS WORKING --->
		<!--- <tr>
			<td class="cs_dlgLabelSmall" valign="top">Default Selected Option:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap"> --->
				
				<!--- // TODO: USE THESE --->
				<!--- <input type="radio" id="#prefix#defaultOptionTypeNone" name="#prefix#defaultOptionType" value="none"<cfif currentValues.defaultOptionType EQ "none"> checked="checked"</cfif>>&nbsp;No Value [""]<br/>
				<input type="radio" id="#prefix#defaultOptionTypeAll" name="#prefix#defaultOptionType" value="all"<cfif currentValues.defaultOptionType EQ "all"> checked="checked"</cfif>>&nbsp;A List of All Available Options (comma-delimited)<br/>
				<input type="radio" id="#prefix#defaultOptionTypeCustom" name="#prefix#defaultOptionType" value="custom"<cfif currentValues.defaultOptionType EQ "custom"> checked="checked"</cfif>>&nbsp;Custom<br/>
				<div id="defaultOptionCustomValueLayer">
					<input type="text" name="#prefix#defaultOptionValue" id="#prefix#defaultOptionValueInput" value="#currentValues.defaultOptionValue#" size="40" />
				</div>
				<input type="radio" id="#prefix#defaultOptionTypeRecord" name="#prefix#defaultOptionType" value="record"<cfif currentValues.defaultOptionType EQ "record"> checked="checked"</cfif>>&nbsp;Select an Organization<br/>
				<div id="defaultOptionRecordValueLayer">
					<select name="#prefix#defaultOptionValue" id="#prefix#defaultOptionValueSelect">
						<option value=""<cfif currentValues.defaultOptionValue EQ ""> selected="selected"</cfif>> - SELECT - </option>
						<cfif ArrayLen(orgData)>
							<cfloop from="1" to="#ArrayLen(orgData)#" index="itm">
								<option value="#orgData[itm].uniqueID#"<cfif currentValues.defaultOptionValue EQ orgData[itm].uniqueID> selected="selected"</cfif>>#orgData[itm].name#</option>
							</cfloop>
						</cfif> 
					</select>
				</div>
				<input type="radio" id="#prefix#defaultOptionTypeUseConfig" name="#prefix#defaultOptionType" value="useconfig"<cfif currentValues.defaultOptionType EQ "useconfig"> checked="checked"</cfif>>&nbsp;Use value from App Config<br/>
				
			</td>
		</tr> --->	
		
<!--- // TODO: DO NOT USE - for reference only --->
<!--- <td class="cs_dlgLabelSmall">Default Selected Option (text value):</td>
<select name="#prefix#allOptionValue" id="#prefix#allOptionValueSelect">
	<option value=""<cfif currentValues.allOptionValue EQ ""> selected="selected"</cfif>> - SELECT - </option>
	<cfif ArrayLen(orgData)>
		<cfloop from="1" to="#ArrayLen(orgData)#" index="itm">
			<option value="#orgData[itm].uniqueID#"<cfif currentValues.allOptionValue EQ orgData[itm].uniqueID> selected="selected"</cfif>>#orgData[itm].name#</option>
		</cfloop>
	</cfif>
	<option value="--other--"<cfif currentValues.allOptionValue EQ ""> selected="selected"</cfif>> - SELECT - </option> 
</select>
<input type="text" name="#prefix#defaultSelectedOption" id="#prefix#defaultSelectedOption" value="#currentValues.defaultSelectedOption#" size="40" />
<br/><span>Leave blank to use the App config value</span> --->
			
		<!--- // // Allow the Config value to be overriden via the Field Props (for now!) --->
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Sort Field:</td>
			<td class="cs_dlgLabelSmall" nowrap="nowrap">
				Name (A-Z)&nbsp;<input type="radio" id="#prefix#optionSortFieldName" name="#prefix#optionSortField" value="name"<cfif currentValues.optionSortField EQ "name"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				Ordinal (0-9999)&nbsp;<input type="radio" id="#prefix#optionSortFieldOrdinal" name="#prefix#optionSortField" value="ordinal"<cfif currentValues.optionSortField EQ "ordinal"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				Use App Config&nbsp;<input type="radio" id="#prefix#optionSortFieldOrdinal" name="#prefix#optionSortField" value="useconfig"<cfif currentValues.optionSortField EQ "useconfig"> checked="checked"</cfif>><br />
			</td>
		</tr> 
		<!--- <input type="hidden" id="#prefix#optionSortField" name="#prefix#optionSortField" value="#currentValues.optionSortField#"> --->
		
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Field Display Type:</td>
			<td class="cs_dlgLabelSmall">
				<input type="radio" name="#prefix#renderField" id="#prefix#renderField" value="yes" <cfif currentValues.renderField eq 'yes'>checked</cfif>>Visible
				<input type="radio" name="#prefix#renderField" id="#prefix#renderField" value="no" <cfif currentValues.renderField eq 'no'>checked</cfif>>Hidden
			</td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Force Loading Scripts:</td>
			<td class="cs_dlgLabelSmall">
				Yes&nbsp;<input type="radio" id="#prefix#forceScriptsYes" name="#prefix#forceScripts" value="1"<cfif currentValues.forceScripts EQ "1"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				No&nbsp;<input type="radio" id="#prefix#forceScriptsNo" name="#prefix#forceScripts" value="0"<cfif currentValues.forceScripts EQ "0"> checked="checked"</cfif>><br />
				<!--- Force the JQuery script to load. --->
			</td>
		</tr>
	</table>
</cfoutput>