<!---
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 
Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.
 
The Original Code is comprised of the PT Calendar directory
 
The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2013.
All Rights Reserved.
 
By downloading, modifying, distributing, using and/or accessing any files
in this directory, you agree to the terms and conditions of the applicable
end user license agreement.
--->
<!---
/* *************************************************************** */
Author: 	
	PaperThin, Inc.
	G. Cronkright 
Custom Field Type:
	Event Category Checkbox Field
Name:
	event_category_checkboxes_props.cfm
Summary:
	Custom Field to select event categories from a list of checkboxes. 
	These categories can be bound to the Calendar Organizations radio button
	field. When a different organization is selected that organizations 
	associated category checkboxes are rendered.
History:
	2011-08-18 - GAC - Created
--->
<cfscript>
	// initialize some of the attributes variables
	typeid = attributes.typeid;
	prefix = attributes.prefix;
	formname = attributes.formname;
	currentValues = attributes.currentValues;

	if ( NOT StructKeyExists(currentValues, "catFieldID") )
		currentValues.catFieldID = "";
	if ( NOT StructKeyExists(currentValues, "catFieldNoneMsg") )
		currentValues.catFieldNoneMsg = "";	
	if ( NOT StructKeyExists(currentValues, "orgFieldID") )
		currentValues.orgFieldID = "";
	if ( NOT StructKeyExists(currentValues, "orgFieldNoneMsg") )
		currentValues.orgFieldNoneMsg = "";
	if ( NOT structKeyExists(currentValues, "forceScripts") )
		currentValues.forceScripts = "0";
	if ( NOT structKeyExists(currentValues, "useOnlyAciveCats") )
		currentValues.useOnlyAciveCats = "0";
	
	// Allow the Config value to be overriden via the Field Props (for now!)
	if ( NOT structKeyExists(currentValues, "optionSortField") ) 
		currentValues.optionSortField = "useconfig";  // name or Ordinal
</cfscript>

<cfoutput>
	<script language="JavaScript" type="text/javascript">
		// register the fields with global props object
		fieldProperties['#typeid#'].paramFields = '#prefix#catFieldID,#prefix#orgFieldID,#prefix#catFieldNoneMsg,#prefix#orgFieldNoneMsg,#prefix#forceScripts,#prefix#useOnlyAciveCats,#prefix#optionSortField';
		// allows this field to support the orange icon (copy down to label from field name)
		fieldProperties['#typeid#'].jsLabelUpdater = '#prefix#doLabel';
		// allows this field to have a common onSubmit Validator
		//fieldProperties['#typeid#'].jsValidator = '#prefix#doValidate';
		// handling the copy label function
		function #prefix#doLabel(str) {
			document.#formname#.#prefix#label.value = str;
		}
		
	/*	
		function #prefix#doValidate() {
			//set the default msgvalue
			document.#formname#.#prefix#msg.value = 'Please enter some text to be converted';
			if( document.#formname#.#prefix#foo.value.length == 0 )
			{
				alert('please Enter some data for foo');
				return false;
			}
			return true;
		}
	*/
	</script>
	<table>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><strong>Category and Organization Field Bindings:</strong></td>
		</tr>	
		<tr>
			<td class="cs_dlgLabelSmall">Category Field ID:</td>
			<td class="cs_dlgLabelSmall">
				<input type="text" name="#prefix#catFieldID" id="#prefix#catFieldID" value="#currentValues.catFieldID#" />
			</td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Organization Field ID:</td>
			<td class="cs_dlgLabelSmall">
				<input type="text" name="#prefix#orgFieldID" id="#prefix#orgFieldID" value="#currentValues.orgFieldID#" />
				<br/>Used to bind this category checkbox field to an organization radio button field.
			</td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><strong>Category and Organization 'No Results' Messages:</strong></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Category Message:</td>
			<td class="cs_dlgLabelSmall">
				<input type="text" name="#prefix#catFieldNoneMsg" id="#prefix#catFieldNoneMsg" value="#currentValues.catFieldNoneMsg#" size="50" />
				<br/>Text to display if no categories are returned. 
			</td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Organization Message:</td>
			<td class="cs_dlgLabelSmall">
				<input type="text" name="#prefix#orgFieldNoneMsg" id="#prefix#orgFieldNoneMsg" value="#currentValues.orgFieldNoneMsg#" size="50" />
				<br/>Text to display if an organization has not been selected. 
				<br/>(Only used if an Organization Field ID has been entered.)
			</td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Only Display Active Categories:</td>
			<td class="cs_dlgLabelSmall">
				Yes <input type="radio" id="#prefix#useOnlyAciveCats" name="#prefix#useOnlyAciveCats" value="1"<cfif currentValues.useOnlyAciveCats EQ "1"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				No <input type="radio" id="#prefix#useOnlyAciveCats" name="#prefix#useOnlyAciveCats" value="0"<cfif currentValues.useOnlyAciveCats EQ "0"> checked="checked"</cfif>><br />
			</td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Sort Field:</td>
			<td class="cs_dlgLabelSmall">
				Name (A-Z) <input type="radio" id="#prefix#optionSortFieldName" name="#prefix#optionSortField" value="name"<cfif currentValues.optionSortField EQ "name"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				Ordinal (0-9) <input type="radio" id="#prefix#optionSortFieldOrdinal" name="#prefix#optionSortField" value="ordinal"<cfif currentValues.optionSortField EQ "ordinal"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				Use App Config <input type="radio" id="#prefix#optionSortFieldConfig" name="#prefix#optionSortField" value="useconfig"<cfif currentValues.optionSortField EQ "useconfig"> checked="checked"</cfif>><br />
			</td>
		</tr>
		<tr>
			<td colspan="2" class="cs_dlgLabelSmall"><hr></td>
		</tr>
		<tr>
			<td class="cs_dlgLabelSmall">Force Loading Scripts:</td>
			<td class="cs_dlgLabelSmall">
				Yes <input type="radio" id="#prefix#forceScripts" name="#prefix#forceScripts" value="1"<cfif currentValues.forceScripts EQ "1"> checked="checked"</cfif>>&nbsp;&nbsp;&nbsp;
				No <input type="radio" id="#prefix#forceScripts" name="#prefix#forceScripts" value="0"<cfif currentValues.forceScripts EQ "0"> checked="checked"</cfif>><br />
				<!--- Force the JQuery script to load. --->
			</td>
		</tr>
	</table>
</cfoutput>